<?php

/**

 * Recorded Game Extension

 * ------------------------------

 * @author jose rolando mdos

 *         @ http://wwww.pia-clan.com

 * @date  : Sbado, 5/11/05 4:24 PM

 * @update: Mircoles, Septiembre 27, 2006 4:03 PM

 * @update: Monday, July 19, 2010 11:35 AM

 **/

 

class RecordedGameNormal extends RecordedGame

{

	function RecordedGameNormal ()

	{

		RecordedGame::RecordedGame();

	}

	function updateRatings ($attach_id, $db)

	{

		global $db;



		require_once ('recmod/LiveRatings.php');

		

		$query = "SELECT r.Id_RecordedGame, r.Mode, r.Plataform, p.Nick, p.Rating, p.Id_Player, p.flag_id

			          FROM " . TABLE_RECGAMES . " r, " . TABLE_RECGAMES_PLAY . " rp, " . TABLE_PLAYERS ." p

					  WHERE r.Id_RecordedGame = rp.Id_RecordedGame

						  AND rp.Id_Player = p.Id_Player

						  AND r.attach_id = '" . $attach_id . "'";

		$result = $db->sql_query ($query);

		

		$load = FALSE;

		$playersData = array ();

		while ($datos = $db->sql_fetchrow ($result))

		{

			if (!$load)

			{

				$load = TRUE;

				$this->mPlataform = $datos['Plataform'];

				$this->mMode = $datos['Mode'];

			}

			$playersData[$datos['Nick']] = array (

				'ID_PLAYER' => $datos['Id_Player'],

				'ID_FLAG' => $datos['flag_id'],

				'nick' => $datos['Nick'],

				'rating' => $datos['Rating'],

                'id' => $datos['Id']

			);

		}

		

		if ($this->mPlataform == PLATAFORM_VOOBLY)

		{

			if (count ($playersData) > 0)

			{

				$this->clearCache (DELETE_NORMAL);

				$liveRatings = new CVooblyLiveRatings ();



				if ($this->mMode == 2)

				{

					$ladder = 9; //DM

				}

				else

				{

					$ladder = 8; //RM

				}

				$liveRatings->setLadderId ($ladder);

				@reset ($playersData);

				foreach ($playersData as $player)

				{

					$liveRatings->addPlayers ($player['nick'], $player);

				}

				unset ($playersData);

				

				$liveRatings->getRatings ();

				

				for ($i = 0; $i < $liveRatings->playersCount (); $i++)

				{

					$player = $liveRatings->getPlayerAt ($i);

					

					if ($player->parsedData['rating'] != $player->ratingData['rating'] && $player->parsedData['rating'] != 0 && $player->parsedData['rating'] != 1600)

					{

						$query = "UPDATE " . TABLE_PLAYERS . "

									SET Rating = '" . $player->parsedData['rating'] . "'";

                        if (intval ($player->ratingData['id']) == 0)

                        {

                            $query .= " , Id = '" . $player->parsedData['id'] . "' ";

                        }

   						$query .= " WHERE Id_Player = '" . $player->ratingData['ID_PLAYER'] . "'";

						$db->sql_query ($query);

					}

				}

			}

		}

	}

	function createFromIdToTemplate ($attach_id, &$db, $esZip = FALSE)

	{

		$fileControl = 'recmod/updatecontrol/rec_' . $attach_id;

		

		if (file_exists ($fileControl))

		{

			if (isset ($_GET['updateratings']) && (filemtime ($fileControl) + 24 * 60 * 60) < time ())

			{

				$this->updateRatings ($attach_id, $db);	

				$fp = fopen ($fileControl, 'w');

				fwrite ($fp, 'ok');

				fclose ($fp);

			}

		}

		else

		{

			$this->updateRatings ($attach_id, $db);	

			$fp = fopen ($fileControl, 'w');

			fwrite ($fp, 'ok');

			fclose ($fp);

		}



		global $aCivData, $aGameData, $aGameModes, $user;

		

		$load = FALSE;

		$templateData = array ();

		

		$query = "SELECT r.*, rp.Team, rp.Id_Civilization, p.Nick, p.Rating, p.Id, p.Id_Player, b.flag_id, b.flag_country, b.flag_image

			          FROM " . TABLE_RECGAMES . " r, " . TABLE_RECGAMES_PLAY . " rp, " . TABLE_PLAYERS ." p, " . 

					  TABLE_FLAGS . " b

				  WHERE r.Id_RecordedGame = rp.Id_RecordedGame

					  AND rp.Id_Player = p.Id_Player

					  AND p.flag_id = b.flag_id

					  AND r.attach_id = '" . $attach_id . "'";

		$result = $db->sql_query ($query);

		

        $teamData = array (

			1 => array (

				'RATING' => 0,

				'FLAG' => array ()

			),

			2 => array (

				'RATING' => 0,

				'FLAG' => array ()

			)			

		);



		while ($datos = $db->sql_fetchrow ($result))

		{

			if (!$load)

			{

				$load = TRUE;

				$this->mIdPlayerView = intval ($datos['Id_Player_View']);

				$this->mMode = $datos['Mode'];

				$this->mPlataform = $datos['Plataform'];

				$this->mMaps = $this->parseMapStringToArray ($datos['Maps']);

				$this->mType = intval ($datos['Id_Gametype']);

				$this->mTourneyName = $datos['Tourney_Name'];

				$this->imageMap = $datos['MapImage'];

				$this->mTeam1 = ( $datos['TeamA'] != "" )  ? stripslashes ($datos['TeamA']) : 'Team A';

				$this->mTeam2 =( $datos['TeamB'] != "" )  ? stripslashes ($datos['TeamB']) : 'Team B';

				$this->playersCount = $datos['Players'];

			}

			

			$datos['Nick'] = stripslashes ($datos['Nick']);

			

			($datos['Team'] == 1) ? ( $teamSigla = 'A' ) : ( $teamSigla = 'B');

			$teamData[$datos['Team']]['RATING'] += $datos['Rating'];

			

			if ( count ($teamData[$datos['Team']]['FLAG']) == 0)

			{

				$teamData[$datos['Team']]['FLAG'] = array ('NAME' => $datos['flag_country'], 'IMG' => $datos['flag_image']);

			}

			else

			{

				if ($teamData[$datos['Team']]['FLAG']['NAME'] != $datos['flag_country'] )

				{

					$teamData[$datos['Team']]['FLAG'] = array (1);

				}

			}

			if ($this->mPlataform == PLATAFORM_IP)

			{

				$datos['Rating'] = '-';

			}



			$this->arrayPlayers[$teamSigla][] = new RecPlayer($datos['Nick'], $datos['Id_Civilization'],  

				$datos['flag_id'], $datos['flag_country'], $datos['flag_image'], $datos['Rating'], $datos['Id']);

				

			if ($this->mIdPlayerView > 0 && $datos['Id_Player'] == $this->mIdPlayerView)

			{

				$templateData['VIEW'] = '<img src="' . PATH_FLAGS . $datos['flag_image'] . '" title="' . $datos['flag_country'] . '" align="texttop"> ' . $datos['Nick'];

				$this->mIdPlayerView = -1;

			}

		}

		

		if ($this->mIdPlayerView == 0 || $templateData['VIEW'] == NULL)

		{

			$templateData['VIEW'] = ' - ';

		}

 		

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$templateData['TEAM_A_R'] = '(' . sprintf("%.2f", $teamData[1]['RATING'] / $this->playersCount) . ')';

			$templateData['TEAM_B_R'] = '(' . sprintf("%.2f", $teamData[2]['RATING'] / $this->playersCount) . ')';

			$templateData['RATING_AVG'] = sprintf ("%.2f", ($teamData[1]['RATING'] + $teamData[2]['RATING']) / ($this->playersCount * 2));

		}

		else

		{

			$templateData['TEAM_A_R'] = '';

			$templateData['TEAM_B_R'] = '';

			$templateData['RATING_AVG'] = "-";

		}

		if ($this->mTourneyName != "")

		{

			$templateData['TYPE'] = $this->mTourneyName . '<br /></b></span><span class="gensmall">(' . $aGameData[$this->mType] . ")";

		}

		else

		{

			$templateData['TYPE'] = $aGameData[$this->mType];

		}

          

		$templateData['MAP'] = "";

		$firstMapName = "";

		$len = count ($this->mapDataInfo);



		for ($j = 0; $j < count ($this->mMaps); $j++)

		{

			for ($i = 0; $i < $len; $i++)

			{

				if ($this->mapDataInfo[$i]['Id_Map'] == $this->mMaps[$j]['ID_MAP'])

				{

					$templateData['MAP'] .= $this->mapDataInfo[$i]['Name'] . " (x" . $this->mMaps[$j]['COUNT'] . ") <br />";	

					

					if ($firstMapName == "")

					{

						$firstMapName = $this->mapDataInfo[$i]['Name'];

					}

					if ($this->imageMap == "")

					{

						$this->imageMap = $this->mapDataInfo[$i];

					}	

					break;				

				}		

			}

		}

		if ($this->mPlataform == PLATAFORM_VOOBLY)

		{

			$templateData['PLATAFORM'] = '<img src="recmod/images/logo_voobly.jpg" title="Voobly.com" />';		

		}

		else // PLATAFORMA_IP

		{

			$templateData['PLATAFORM'] = 'IP Game';

		}



		if ( is_array ($this->imageMap))

		{

			$templateData['MAP_IMG'] = '<img src="' . PATH_TO_MAPS . $this->imageMap['Image'] . '" title="' . $this->imageMap['Name'] . '">';

		} 

		else if ($this->imageMap != '')

		{

			$templateData['MAP_IMG'] = '<img src="' . PATH_TO_UPLOADED_MAPS . $this->imageMap . '" title="' . $firstMapName . '">';

		}

      

		$templateData['MODE'] = $aGameModes[intval ($this->mMode)];

		$templateData['PLAYERS'] = $this->playersCount;

		

		$templateData['TEAM_A'] = $this->mTeam1;

		$templateData['TEAM_A_I'] = ( count ($teamData[1]['FLAG'] ) > 1 && $teamData[1]['FLAG']['NAME'] != 'Blank') ? ( '<img src="' . PATH_FLAGS . $teamData[1]['FLAG']['IMG'] .'" title="' . $teamData[1]['FLAG']['NAME'] . '" align="top">' ) : ( FLAG_INTERNACIONAL );

		

		$templateData['TEAM_B'] = $this->mTeam2;

		$templateData['TEAM_B_I'] = ( count ($teamData[2]['FLAG'] ) > 1 && $teamData[2]['FLAG']['NAME'] != 'Blank' ) ? ( '<img src="' . PATH_FLAGS . $teamData[2]['FLAG']['IMG'] .'" title="' . $teamData[2]['FLAG']['NAME'] . '" align="top">' ) : ( FLAG_INTERNACIONAL );

		



		$this->objTemplate->set_filenames ( array (

			'players1' => 'recorded_game_players1.html')

		);

		$this->objTemplate->set_filenames ( array (

			'players2' => 'recorded_game_players2.html')

		);

		

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->arrayPlayers['A'][$i]))

			{

				$this->objTemplate->assign_block_vars ('p1', 

					$this->arrayPlayers['A'][$i]->toArray ()

				);

			}

			if (is_object ($this->arrayPlayers['B'][$i]))

			{

				$this->objTemplate->assign_block_vars ('p2', 

					$this->arrayPlayers['B'][$i]->toArray ()

				);

			}

		}

		$templateData['PLAYERS_DATA1'] = $this->objTemplate->assign_display ('players1');

		$templateData['PLAYERS_DATA2'] = $this->objTemplate->assign_display ('players2');

		

        $this->objTemplate->destroy_block_vars ('p1');

		$this->objTemplate->destroy_block_vars ('p2');

		

        if (isset ($_GET['updateratings']))

		{

			$templateData['UPDATE'] = '';			

		}

		else

		{

			$templateData['UPDATE'] = '<div style="float: right; font-size: 10px;"><a href="javascript:updateRatings()">Update Ratings</a></div>';

		}

		return $templateData;

	}



	function saveOnDbInsert ($attach_id, &$db)

	{

		$strNicks = "";

		for ($i = 0; $i < 4; $i++)

		{

			if (is_object ($this->arrayPlayers['A'][$i]))

			{

				$strNicks .= "'" . addslashes ($this->arrayPlayers['A'][$i]->getNick ()) . "',";

			}

			if (is_object ($this->arrayPlayers['B'][$i]))

			{

				$strNicks .= "'" . addslashes ($this->arrayPlayers['B'][$i]->getNick ()) . "',";

			}

		}

		if ($i > 0)

		{

			$strNicks = rtrim ($strNicks, ",");

		}



		if ($this->mPlataform == PLATAFORM_VOOBLY && $this->mMode == 2)

		{

			$this->mPlataformReal = PLATAFORM_VOOBLY_DM;

		}

		else

		{

			$this->mPlataformReal = $this->mPlataform;

		}



		$query = "SELECT Id_Player, flag_id, Nick, Rating

					 FROM " . TABLE_PLAYERS . "

					 WHERE Nick IN (" . $strNicks . ")";

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$query .= " AND Plataform = '" . $this->mPlataformReal . "'";

		}

		$query .= " GROUP BY Nick

					ORDER BY flag_id DESC, Rating DESC";

		$result = $db->sql_query ($query);

		

		$mIdPlayerView = 0;

		$data = array ();

		

		if ($this->mPlayerView == '')

		{

			$mIdPlayerView = -1;

		}

		

		while ($playerData = $db->sql_fetchrow ($result))

		{

			$playerData['Nick'] = stripslashes ($playerData['Nick']);

			$data[] = $playerData;

			if ($mIdPlayerView == 0 && strcasecmp ($playerData['Nick'], $this->mPlayerView) == 0)

			{

				$mIdPlayerView = $playerData['Id_Player'];

			}

		}



		$players = count ($this->arrayPlayers['A']);

		

		$this->deleteInfo ($attach_id);

				

		$query = "INSERT INTO " . TABLE_RECGAMES . " VALUES (

					NULL, 

					'".  $attach_id . "',

					'" . $this->mType. "',

					'" . addslashes ($this->mTeam1) . "', 

					'" . addslashes ($this->mTeam2) . "',

					'" . $players . "',

					'0',

					'" . $this->mMaps . "',

					'" . addslashes ($this->mTourneyName) . "',

					'" . abs ($mIdPlayerView) . "',

					'" . $this->imageMap . "',

					'" . $this->mMode . "',

					'" . $this->mPlataform . "'

					)";

		$db->sql_query ($query);

		$this->idRecordedGame = $db->sql_nextid ();

		

		for ($i = 0; $i < 4; $i++)

		{

			if (is_object ($this->arrayPlayers['A'][$i]))

			{

				$query = "INSERT INTO ".TABLE_RECGAMES_PLAY." VALUES (

							  '" . $this->idRecordedGame . "', 

							  '" . $this->arrayPlayers['A'][$i]->getIdPlayer ($data, $db, $this->mPlataformReal) ."',

							  '1',

							  '" . $this->arrayPlayers['A'][$i]->getIdCivilization () ."')";

				$db->sql_query ($query);



				if ($mIdPlayerView == 0 && strcasecmp ($this->arrayPlayers['A'][$i]->getNick (), $this->mPlayerView) == 0)

				{

                    $mIdPlayerView = $this->arrayPlayers['A'][$i]->mId;

				}

			}

			if (is_object ($this->arrayPlayers['B'][$i]))

			{

				$query = "INSERT INTO ".TABLE_RECGAMES_PLAY." VALUES(

					  '" . $this->idRecordedGame . "', 

					  '" . $this->arrayPlayers['B'][$i]->getIdPlayer ($data, $db, $this->mPlataformReal) ."',

					  '2',

					  '" . $this->arrayPlayers['B'][$i]->getIdCivilization () ."')";

				$db->sql_query ($query);



				if ($mIdPlayerView == 0 && strcasecmp ($this->arrayPlayers['B'][$i]->getNick (), $this->mPlayerView) == 0)

				{

					$mIdPlayerView = $this->arrayPlayers['B'][$i]->mId;

				}				

			}

		}

		if ($mIdPlayerView > 0)

		{

            $queryUpdate = "UPDATE " . TABLE_RECGAMES . "

                                SET Id_Player_View = '" . $mIdPlayerView . "'

			                    WHERE Id_RecordedGame = '" . $this->idRecordedGame . "'";

			$db->sql_query ($queryUpdate);

		}

	}

	function saveOnDb ($attach_id, &$db)

	{

		if (!$this->validRecGameInfo)

		{

			return;

		}

		

		$this->clearCache (DELETE_NORMAL);

		

		if ($this->idRecordedGame > 0)

		{

			$this->saveOnDbUpdate ($db);

		}

		else

		{

			$this->saveOnDbInsert ($attach_id, $db);

		}

	}

	

	function saveOnDbUpdate (&$db)

	{

		$strNicks = "";

		for ($i = 0; $i < 4; $i++)

		{

			if (is_object ($this->arrayPlayers['A'][$i]))

			{

				$strNicks .= "'" . addslashes ($this->arrayPlayers['A'][$i]->getNick ()) . "',";

			}

			if (is_object ($this->arrayPlayers['B'][$i]))

			{

				$strNicks .= "'" . addslashes ($this->arrayPlayers['B'][$i]->getNick ()) . "',";

			}

		}

		if ($i > 0)

		{

			$strNicks = rtrim ($strNicks, ",");

		}

		

		if ($this->mPlataform == PLATAFORM_VOOBLY && $this->mMode == 2)

		{

			$this->mPlataformReal = PLATAFORM_VOOBLY_DM;

		}

		else

		{

			$this->mPlataformReal = $this->mPlataform;

		}

		

		$query = "SELECT Id_Player, flag_id, Nick, Rating

					 FROM " . TABLE_PLAYERS . "

					 WHERE Nick IN (" . $strNicks . ")";

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$query .= " AND Plataform = '" . $this->mPlataformReal . "'";

		}

		$query .= " GROUP BY Nick

					ORDER BY flag_id DESC, Rating DESC";

					

		$data = array ();

		$mIdPlayerView = 0;

		if ($this->mPlayerView == '')

		{

			$mIdPlayerView = -1;

		}

		

		$result = $db->sql_query ($query);

		while ($playerData = $db->sql_fetchrow ($result))

		{

			$data[] = $playerData;

			if ($mIdPlayerView == 0 && strcasecmp ($playerData['Nick'], $this->mPlayerView) == 0)

			{

				$mIdPlayerView = $playerData['Id_Player'];

			}

		}

		$playersCount = count ($this->arrayPlayers['A']);

		

		$query = "UPDATE ".TABLE_RECGAMES." SET

					Id_Gametype  = '" . $this->mType. "',

					TeamA = '" . addslashes ($this->mTeam1) . "', 

					TeamB = '" . addslashes ($this->mTeam2) . "',

					Players = '" . $playersCount . "',

					Id_Player = '0',

					Maps = '" . $this->mMaps . "',

				 	Tourney_Name  = '" . addslashes ($this->mTourneyName) . "',

					Id_Player_View = '" . $mIdPlayerView . "',

					Mode = '" . $this->mMode . "',

					Plataform  = '" . $this->mPlataform . "'

				 WHERE Id_RecordedGame = '".  $this->idRecordedGame . "'";

		

        $db->sql_query ($query);

		

		$query = "DELETE FROM " . TABLE_RECGAMES_PLAY . "

					  WHERE Id_RecordedGame = '" . $this->idRecordedGame . "'";

		$db->sql_query ($query);				  

		

		

		for ($i = 0; $i < $playersCount; $i++)

		{

			if (is_object ($this->arrayPlayers['A'][$i]))

			{

				$query = "INSERT INTO ".TABLE_RECGAMES_PLAY." VALUES(

					  '" . $this->idRecordedGame . "', 

					  '" . $this->arrayPlayers['A'][$i]->getIdPlayer ($data, $db, $this->mPlataformReal) ."',

					  '1',

					  '" . $this->arrayPlayers['A'][$i]->getIdCivilization () ."')";

				$db->sql_query ($query);

				

				if ($mIdPlayerView == 0 && strcasecmp ($this->arrayPlayers['A'][$i]->getNick (), $this->mPlayerView) == 0)

				{

 					$mIdPlayerView = $this->arrayPlayers['A'][$i]->mId;

				}

			}

			if (is_object ($this->arrayPlayers['B'][$i]))

			{

				$query = "INSERT INTO ".TABLE_RECGAMES_PLAY." VALUES(

					  '" . $this->idRecordedGame . "', 

					  '" . $this->arrayPlayers['B'][$i]->getIdPlayer ($data, $db, $this->mPlataformReal) ."',

					  '2',

					  '" . $this->arrayPlayers['B'][$i]->getIdCivilization () ."')";

				$db->sql_query ($query);

				

				if ($mIdPlayerView == 0 && strcasecmp ($this->arrayPlayers['B'][$i]->getNick (), $this->mPlayerView) == 0)

				{

                    $mIdPlayerView = $this->arrayPlayers['B'][$i]->mId;

				}				

			}

		}

        if ($mIdPlayerView > 0)

        {

            $queryUpdate = "UPDATE " . TABLE_RECGAMES . "

                                SET Id_Player_View = '" . $mIdPlayerView . "'

                                WHERE Id_RecordedGame = '" . $this->idRecordedGame . "'";

            $db->sql_query ($queryUpdate);

        }

	}

	function CreateGame ($file = '', $imageMap = '')

	{

		if ($file != '')

		{

			$this->CreateGameFromPostInfoAnalisis ($file, $imageMap, $_POST['gametype'], $_POST['tourneyname'], $_POST['plataform'], $_POST['teama'], $_POST['teamb']);

		}

		else

		{          

			$this->CreateGameFromPostInfo ($_POST['plataform'], $_POST['mode'], $_POST['mapas_data'], $_POST['gametype'], $_POST['tourneyname'], $_POST['players'],

					$_POST['teama'], $_POST['teamb'], $_POST, $_POST['playerview'], $_POST['idrecgame']);	

		}

	}



	function CreateGameFromPostInfoAnalisis ($strFile, $imageMap, $iType, $strTourneyName, $iPlataform, $strTeam1, $strTeam2, $iIdRecordedGame = 0)

	{

		require_once ('recmod/dUnzip.inc.php');

		require_once ('recmod/RecordedGameReader.php');

		

		

		$this->idRecordedGame = intval ($iIdRecordedGame);

		$this->mMaps = array (); 

		$this->mMode = 0;

		$this->mMapIds = array ();

		$this->mType = intval ($iType);

		$this->mPlataform = intval ($iPlataform);

		$this->imageMap = $imageMap;

		

		if ($this->mType == 4)

		{

			$this->mTourneyName = trim ($strTourneyName);

		}

		else

		{

			$this->mTourneyName = '';

		}

		

		$zipFile = new dUnzip2 ($strFile);

		$list = $zipFile->getList();



		$first = TRUE;

		$this->validRecGameInfo = FALSE;			

		foreach ($list as $fileName => $zippedFile)

		{

			($first) ? $fileMap = $strFileMap : $fileMap = '';



			$zipFile->unzip ($zippedFile['file_name'], 'cache/analizer/rec.mgx');

			$analizer = new RecordedGameReader ('cache/analizer/rec.mgx', $this->imageMap, 200);



			if ($first)

			{

				$sucess = $analizer->read (MGX_COMPLETE);

			}

			else

			{

				$sucess = $analizer->read (MGX_MAPNAME_ONLY);

			}

			

			if ($sucess)

			{

				$this->validRecGameInfo = TRUE;			

				if ($first)

				{

					$this->mMode = $analizer->gameTypeId;

					

					@reset ($analizer->mPlayersInfo);

					foreach ($analizer->mPlayersInfo as $player)

					{

						if ($first)

						{

							$first = FALSE;

							$teamA = $player['team'];

							

						}

						if ($player['Name'] != '')

						{

							if ($teamA == $player['team'])

							{

								$this->arrayPlayers['A'][] = new RecPlayer ($player['Name'], $player['Id_Civ'], 0);

							}

							else

							{

								$this->arrayPlayers['B'][] = new RecPlayer ($player['Name'], $player['Id_Civ'], 0);

							}

						}

						if ($player['Key'] == $analizer->mIdPlayerView)

						{

							$this->mPlayerView = $player['Name'];

						}

					}

				}

				if ($analizer->mMapId == 44 || $analizer->mMapId == 30)

				{

					$this->mMaps[] = $analizer->mapName;

				}

				else

				{

					$this->mMapIds[] = $analizer->mMapId;

				}

				$first = FALSE;

			}

		}

		$this->playersCount = count ($this->arrayPlayers['A']);

		$this->mTeam1 = trim ($strTeam1);

		$this->mTeam2 = trim ($strTeam2);

		

		$this->AnalizeTeamName ();

		$this->mMaps = $this->processMapArrayToStringAnalized ();

	}



	function AnalizeName ($teamKey)

	{

		if (is_object ($this->arrayPlayers[$teamKey][0]))

		{

			$nick = $this->arrayPlayers[$teamKey][0]->getNick ();

			

			if (strpos ($nick, '[') < strpos ($nick, ']'))

			{

				$team = substr ($nick, strpos ($nick, '[') + 1, strpos ($nick, ']') - 1);;

			}

			else

			{

				for ($i = 6; $i >= 2; $i--)

				{

					$posibleTag = substr ($nick, 0, $i);

					$fallo = FALSE;

					for ($j = 1; $j < count ($this->arrayPlayers[$teamKey]); $j++)

					{

						if (!eregi ($posibleTag, $this->arrayPlayers[$teamKey][$j]->getNick ()))

						{

							$fallo = TRUE;

							break;

						}

					}

					if (!$fallo)

					{

						$team = $posibleTag;

						break;

					}

				}

				if ($fallo)

				{

					for ($i = 6; $i >= 2; $i--)

					{

						$posibleTag = substr ($nick, strlen ($nick) - $i);

						$fallo = FALSE;

						for ($j = 1; $j < count ($this->arrayPlayers[$teamKey]); $j++)

						{

							if (!eregi ($posibleTag, $this->arrayPlayers[$teamKey][$j]->getNick ()))

							{

								$fallo = TRUE;

								break;

							}

						}

						if (!$fallo)

						{

							$team = $posibleTag;

							break;

						}

					}

				}

			}

			return trim (str_replace (array ('_', '[', ']'), array (' ', '', ''), $team));

		}

		else return '';

	}

	function AnalizeTeamName ()

	{

		if ($this->mTeam1 == "")

		{

			if ($this->playersCount == 1)

			{

				if (is_object ($this->arrayPlayers['A'][0]))

				{

					$this->mTeam1 = $this->AnalizeTeamNameSingle ($this->arrayPlayers['A'][0]->getNick ());

				}

			}

			else

			{

				$this->mTeam1 = $this->AnalizeName ('A');

			}

		}

		if ($this->mTeam2 == "")

		{

			if ($this->playersCount == 1)

			{

				if (is_object ($this->arrayPlayers['B'][0]))

				{

					$this->mTeam2 = $this->AnalizeTeamNameSingle ($this->arrayPlayers['B'][0]->getNick ());

				}

			}

			else

			{

				$this->mTeam2 = $this->AnalizeName ('B');

			}

		}

	}

	function AnalizeTeamNameSingle ($nick)

	{

		if ($nick[0] == '[' && strpos ($nick, ']') > 1)

		{

			return substr ($nick, 1, strpos ($nick, ']') - 1);

		}

		for ($i = 0; $i < strlen ($nick); $i++)

		{

			if ($nick[$i] == '_')

			{

				$nick[$i] = ' ';

			}

			else

			{

				break;

			}

		}

		for ($i = strlen ($nick) - 1; $i >= 0; $i--)

		{

			if ($nick[$i] == '_')

			{

				$nick[$i] = ' ';

			}

			else

			{

				break;

			}

		}

		$nick = trim ($nick);

		$parts = split ("_", $nick);

		$posibleTag = '';

		if (count ($parts) > 1 && !is_numeric ($parts[0]))

		{

			if (strcasecmp ($parts[0], "L") == 0 && strcasecmp ($parts[1], "Clan") == 0)

			{

				$posibleTag = "L Clan";

			}

			else if (strlen ($parts[0]) > 1)

			{

				$posibleTag = $parts[0];

			}

		}

		

		if (is_numeric ($parts[0]))

		{

			$posibleTag = $parts[count ($parts) - 1];

		}

		$posibleTag = str_replace (array ('[', ']'), array ('', ''), $posibleTag);

		return $posibleTag;

	}

	function CreateGameFromPostInfo ($iPlataform, $iMode, $strMapData, $iType, $strTourneyName, $playersCount, 

									$strTeam1, $strTeam2, $arrayPlayersInfo, $playerView, $iIdRecordedGame = 0)

	{

		$this->mPlataform = intval ($iPlataform);

		$this->mMode = intval ($iMode);

		$this->idRecordedGame = intval ($iIdRecordedGame);

		$this->mMaps = $this->parseMapArrayToString ($this->parseMapStringToArray ($strMapData));

		$this->mType = intval ($iType);



		$this->mMode = intval ($iMode);

		$this->mPlayerView = trim ($playerView);

		

		$this->validRecGameInfo = TRUE;

		

		if ($this->mType == 4)

		{

			$this->mTourneyName = trim ($strTourneyName);

		}

		else

		{

			$this->mTourneyName = '';

		}

		$this->mTeam1 = trim ($strTeam1);

		$this->mTeam2 = trim ($strTeam2);

		

		$this->playersCount = intval ($playersCount);

		           

		$existsViewPlayer = FALSE;

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			$arrayPlayersInfo['playerNickA'][$i] = trim ($arrayPlayersInfo['playerNickA'][$i]);

			if ($arrayPlayersInfo['playerNickA'][$i] != "")

			{

				if (strcasecmp ($this->mPlayerView, $arrayPlayersInfo['playerNickA'][$i]) == 0)

				{

					$existsViewPlayer = TRUE;

				}

				$this->arrayPlayers['A'][] = new RecPlayer($arrayPlayersInfo['playerNickA'][$i], $arrayPlayersInfo['playerCivA'][$i], 

					$arrayPlayersInfo['playerFlagA'][$i]);

			}



			$arrayPlayersInfo['playerNickB'][$i] = trim ($arrayPlayersInfo['playerNickB'][$i]);

			if ($arrayPlayersInfo['playerNickB'][$i] != "" )

			{

				if (strcasecmp ($this->mPlayerView, $arrayPlayersInfo['playerNickB'][$i]) == 0)

				{

					$existsViewPlayer = TRUE;

				}			

				$this->arrayPlayers['B'][] = new RecPlayer($arrayPlayersInfo['playerNickB'][$i], $arrayPlayersInfo['playerCivB'][$i], 

					$arrayPlayersInfo['playerFlagB'][$i]);

			}

		}

     

		if (!$existsViewPlayer)

		{

			$this->mPlayerView = '';

		}

	}



	function showEdit ($attach_id, &$db)

	{

		global $user, $aGameData;

		

		require ('recmod/aoc_lang.php');

		

		$query = "SELECT r.*, rp.Team, rp.Id_Civilization, p.Id_Player, p.Nick, b.flag_id

		            FROM " . TABLE_RECGAMES . " r, " . TABLE_RECGAMES_PLAY . " rp, " . TABLE_PLAYERS ." p, " . 

				            TABLE_FLAGS . " b

				    WHERE r.Id_RecordedGame = rp.Id_RecordedGame

					  AND rp.Id_Player = p.Id_Player

					  AND p.flag_id = b.flag_id

					  AND r.attach_id = '" . $attach_id . "'";

		$result = $db->sql_query ($query);

		$load = FALSE;

		while ($datos = $db->sql_fetchrow ($result))

		{

			if (!$load)

			{

				$load = TRUE;

				$this->mMaps = $this->parseMapStringToArray ($datos['Maps']);

				$this->mType = intval ($datos['Id_Gametype']);

				$this->mMode = $datos['Mode'];

				$this->mPlataform = $datos['Plataform'];

				$this->mTourneyName = $datos['Tourney_Name'];

				$this->mTeam1 = $datos['TeamA'];

				$this->mTeam2 = $datos['TeamB'];

				$this->mPlayerViewId = $datos['Id_Player_View']; 

				$this->playersCount = $datos['Players'];

			}

			

			if ($this->mPlayerViewId == $datos['Id_Player'])

			{

				$this->mPlayerViewNick = $datos['Nick'];

			}

			($datos['Team'] == 1) ? ( $teamSigla = 'A' ) : ( $teamSigla = 'B');

			

			$team[$datos['Team']]['RATING'] += $datos['Rating'];

			

			$this->arrayPlayers[$teamSigla][] = new RecPlayer($datos['Nick'], $datos['Id_Civilization'], $datos['flag_id']);

		}

         

		$query = "SELECT flag_country, flag_id, flag_image

				  FROM " . TABLE_FLAGS . "

				  WHERE flag_id <> 0

				  ORDER BY flag_country ASC";

		$aFlags = $db->sql_fetchrowset ($db->sql_query ($query));



		$arrayFlags = array_merge (array (-1 => array(

			'flag_id' => 0,

			'flag_country' => "Country")) , $aFlags);

		

		$len = count ($this->mMaps);

		$lenMap = count ($this->mapDataInfo);

		

		$mgxInfo = array ();

		$mgxInfo['mapas_si'] = array ();

		for ($i = 0; $i < $len; $i++)

		{

			for ($j = 0; $j < $lenMap; $j++)

			{

				if ($this->mMaps[$i]['ID_MAP'] == $this->mapDataInfo[$j]['Id_Map'])

				{

					$this->objTemplate->assign_block_vars ('maps_added', array (

						'VALUE' => $this->mapDataInfo[$j]['Id_Map'] . ";	" . $this->mMaps[$i]['COUNT'],

						'NAME' => $this->mapDataInfo[$j]['Name'] . " (x" . $this->mMaps[$i]['COUNT'] . ")")

					);

				}

			}

		}

		for ($j = 0; $j < $lenMap; $j++)

		{

			$this->objTemplate->assign_block_vars ('maps', array (

				'VALUE' => $this->mapDataInfo[$j]['Id_Map'],

				'NAME' => $this->mapDataInfo[$j]['Name'])

			);

		}

		

		@reset ($aGameModes);

		foreach ($aGameModes as $key => $value)

		{

			$this->objTemplate->assign_block_vars ('modes', array (

				'VALUE' => $key,

				'NAME' => $value,

				'SELECTED' => ( $this->mMode == $key ) ? ( 'selected' ) : ( '' )

			));	

		}



		@reset ($aGameData);

		foreach ($aGameData as $key => $value)

		{

			$this->objTemplate->assign_block_vars ('types', array (

				'VALUE' => $key,

				'NAME' => $value,

				'SELECTED' => ( $this->mType == $key ) ? ( 'selected' ) : ( '' )

			));

		}

		

		

		for ($i = 1; $i <= 4; $i++)

		{

			$this->objTemplate->assign_block_vars ('playersc', array (

				'VALUE' => $i,

				'NAME' => $i . " vs " . $i,

				'SELECTED' => ( $this->playersCount == $i ) ? ( 'selected' ) : ( '' )

			));

		}

         

		$this->objTemplate->assign_vars ( array (

			'TEAMA' => $this->mTeam1,

			'TEAMB' => $this->mTeam2,

			'TOURNEY' => $this->mTourneyName,

			'PLAYER_VIEW' => $this->mPlayerViewNick)

		);



		if (in_array ($this->mPlataform, array (1,2)))

		{

			$this->objTemplate->assign_vars ( array (

				'VOOBLY_CHECKED' => 'checked="checked" ',

				'IP_CHECKED' => '')

			);

		}

		else

		{

			$this->objTemplate->assign_vars ( array (

				'IP_CHECKED' => 'checked="checked" ',

				'VOOBLY_CHECKED' => '')

			);

		}



		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->arrayPlayers['A'][$i]))

			{

				$this->arrayPlayers['A'][$i]->printPlayerToEdit ($arrayFlags, $this->objTemplate, $i + 1);

			}

			if (is_object ($this->arrayPlayers['B'][$i]))

			{

				$this->arrayPlayers['B'][$i]->printPlayerToEdit ($arrayFlags, $this->objTemplate, $i + 5);

			}

		}

		if ($this->playersCount < 4)

		{

			for ($i = $this->playersCount + 1; $i <= 4; $i++)

			{

				@reset ($aCivData);

				@reset ($arrayFlags);

				while (list ($iKey, $arrayValue ) = each ($aCivData))

				{

					$this->objTemplate->assign_block_vars ('civs' . $i , array (

						'VALUE' => $iKey,

						'NAME' => $arrayValue['NAME']

					));

				}

				while (list ($iKey, $arrayValue ) = each ($arrayFlags))

				{

					$this->objTemplate->assign_block_vars ('flag' . $i, array (

						'VALUE' => $iKey,

						'NAME' => $arrayValue['flag_country']

					));

				}

				@reset ($aCivData);

				@reset ($arrayFlags);

				while (list ($iKey, $arrayValue ) = each ($aCivData))

				{

					$this->objTemplate->assign_block_vars ('civs' . ($i + 4) , array (

						'VALUE' => $iKey,

						'NAME' => $arrayValue['NAME']

					));

				}

				while (list ($iKey, $arrayValue ) = each ($arrayFlags))

				{

					$this->objTemplate->assign_block_vars ('flag' . ($i + 4), array (

						'VALUE' => $iKey,

						'NAME' => $arrayValue['flag_country']

					));

				}

			}

		}		

	}



}

?>