<?

/**

 * Recorded Game Extension

 * ------------------------------

 * @author jose rolando mdos

 *         @ http://wwww.pia-clan.com

 * @date  : Sbado, 5/11/05 4:24 PM

 * @update: Mircoles, Septiembre 27, 2006 4:03 PM

 * @update: Monday, July 19, 2010 11:28 AM

 **/

 

class RecordedGamePack extends RecordedGame

{

	function RecordedGamePack ()

	{

		RecordedGame::RecordedGame();

	}



	function updateRatings ($attach_id, &$db)

	{

		global $db;

		

		require_once ('recmod/LiveRatings.php');

		

		$query = "SELECT play.Id_Player as Main_Id, play.Id as Main_Id_Plataform, play.Nick as Main_Nick, play.Rating as Main_Rating, play.flag_id as Main_Id_Flag,

						  p.Id_Player, p.Nick, p.Rating, p.flag_id, r.Mode, r.Plataform, p.Id

				  FROM " . TABLE_RECGAMES . " r, " . TABLE_REC_PACKGAMES . " pak, " . TABLE_PLAYERS . " p, " . TABLE_PLAYERS . " play

				  WHERE r.Id_RecordedGame = pak.Id_RecordedGame

					  AND pak.Id_Rival = p.Id_Player

					  AND r.attach_id = '" . $attach_id . "'

					  AND r.Id_Player = play.Id_Player";

		$result = $db->sql_query ($query);

		$load = FALSE;

		$playersData = array ();

		

		while ($datos = $db->sql_fetchrow ($result))

		{

			if (!$load)

			{

				$load = TRUE;

				$playersData[$datos['Main_Nick']] = array (

					'ID_PLAYER' => $datos['Main_Id'],

					'ID_FLAG' => $datos['Main_Id_Flag'],

					'nick' => $datos['Main_Nick'],

					'rating' => $datos['Main_Rating'],

                    'id' => $datos['Main_Id_Plataform']

				);

				$this->mPlataform = $datos['Plataform'];

				$this->mMode = $datos['Mode'];

			}

			$playersData[$datos['Nick']] = array (

				'ID_PLAYER' => $datos['Id_Player'],

				'ID_FLAG' => $datos['flag_id'],

				'nick' => $datos['Nick'],

				'rating' => $datos['Rating'],

                'id' => $datos['Id']

			);

		}



		if ($this->mPlataform == PLATAFORM_VOOBLY)

		{

			if (count ($playersData) > 0)

			{

				$this->clearCache (DELETE_PACK);

				$liveRatings = new CVooblyLiveRatings ();



				if ($this->mMode == 2)

				{

					$ladder = 9; // DM';

				}

				else

				{

					$ladder = 8; //RM';

				}

				$liveRatings->setLadderId ($ladder);

				@reset ($playersData);

				foreach ($playersData as $player)

				{

					$liveRatings->addPlayers ($player['nick'], $player);

				}

				unset ($playersData);



				$liveRatings->getRatings ();



				for ($i = 0; $i < $liveRatings->playersCount (); $i++)

				{

					$player = $liveRatings->getPlayerAt ($i);



					if ($player->parsedData['rating'] != $player->ratingData['rating'] && $player->parsedData['rating'] != 0 && $player->parsedData['rating'] != 1600)

					{

						$query = "UPDATE " . TABLE_PLAYERS . "

									SET Rating = '" . $player->parsedData['rating'] . "'";

						if (intval ($player->ratingData['id']) == 0)

                        {

                            $query .= " , Id = '" . $player->parsedData['id'] . "' ";

                        }



						$query .= " WHERE Id_Player = '" . $player->ratingData['ID_PLAYER'] . "'";

						$result = $db->sql_query ($query);

					}

				}

			}

		}

		

	}



	function createFromIdToTemplate ($attach_id, &$db, $esZip = FALSE, $id_player = 0)

	{

		global $aCivData, $user, $aGameModes, $aGameData, $db;

		$returnData = array ();

		

		$fileControl = 'recmod/updatecontrol/rec_' . $attach_id;

		

		if (file_exists ($fileControl))

		{

			if (isset ($_GET['updateratings']) && (filemtime ($fileControl) + 24 * 60 * 60) < time ())

			{

				$this->updateRatings ($attach_id, $db);	

				$fp = fopen ($fileControl, 'w');

				fwrite ($fp, 'ok');

				fclose ($fp);

			}

		}

		else

		{

			$this->updateRatings ($attach_id, $db);	

			$fp = fopen ($fileControl, 'w');

			fwrite ($fp, 'ok');

			fclose ($fp);

		}

		

		$query = "SELECT r.Players, play.Id_Player as Main_Id, play.Id as Main_Id_Plataform, play.Nick as Main_Nick, play.Rating as Main_Rating, ba.flag_id as Main_Id_Flag, ba.flag_country as Main_Flag, ba.flag_image as Main_Flag_Url,

				        pak.Id_Civilization, p.Nick, p.Rating, p.Id, b.flag_id, b.flag_image, b.flag_country, pak.Maps, pak.Id_CivRival, r.Mode, r.Id_Gametype, r.Tourney_Name, r.MapImage, r.Plataform

				  FROM " . TABLE_RECGAMES . " r, " . TABLE_REC_PACKGAMES . " pak, " . TABLE_PLAYERS . " p, " . TABLE_FLAGS." b," . TABLE_PLAYERS . " play,

				        " . TABLE_FLAGS . " ba

				  WHERE r.Id_RecordedGame = pak.Id_RecordedGame

				      AND pak.Id_Rival = p.Id_Player

				      AND p.flag_id = b.flag_id

				      AND r.attach_id = '" . $attach_id . "'

				      AND r.Id_Player = play.Id_Player

				      AND play.flag_id = ba.flag_id";

		$result = $db->sql_query ($query);

		

		$load = FALSE;

		$rating = 0;

		$counter = 1;

		$templateData = array ();

		$playersCounter = array ();

		

		while ($datos = $db->sql_fetchrow ($result))

		{

			if (!$load)

			{

				$load = TRUE;

				$this->mPlataform = $datos['Plataform'];

				if ($this->mPlataform == PLATAFORM_IP)

				{

					$datos['Main_Rating'] = '-';

				}

				$this->mPlayer = new RecPlayer ($datos['Main_Nick'], 0, $datos['Main_Id_Flag'], $datos['Main_Flag'], $datos['Main_Flag_Url'], 

					$datos['Main_Rating'], $datos['Main_Id_Plataform']);

			

				$this->playersCount = $datos['Players'];

				$rating += $datos['Main_Rating'];

				$this->imageMap = $datos['MapImage'];

				

				$this->mMode = $datos['Mode'];

				$this->mType = ( $datos['Id_Gametype'] == 0 ) ? 2 : $datos['Id_Gametype'];

				$this->mTourneyName = $datos['Tourney_Name'];

			}

			$data = split (";", $datos['Maps']);

			$arrayData[] = array (

				'ID_CIV' => intval ($datos['Id_Civilization']), 

				'ID_MAP' => $data[0],

				'COUNT' => $data[1]

			);

					

			if ($this->mPlataform != PLATAFORM_IP)

			{

				$rating += $datos['Rating'];

				$counter++;			

			}

			else

			{

				$datos['Rating'] = '';			

			}

			$this->arrayPlayers[] = new RecPlayer($datos['Nick'], $datos['Id_CivRival'],  

				$datos['flag_id'], $datos['flag_country'], $datos['flag_image'], $datos['Rating'], $datos['Id']);



			$playersCounter[] = $datos['Nick'];

		}



		$templateData['PLAYERS'] = count (array_unique ($playersCounter));



		if ($this->mTourneyName != "")

		{

			$templateData['TYPE'] = $this->mTourneyName . '<br /></b></span><span class="gensmall">(' . $aGameData[$this->mType] . ")";

		}

		else

		{

			$templateData['TYPE'] = $aGameData[$this->mType];

		}



		if ($this->mPlataform == PLATAFORM_VOOBLY)

		{

			$templateData['PLATAFORM'] = '<img src="recmod/images/logo_voobly.jpg" title="Voobly.com" />';		

		}

		else // PLATAFORMA_IP

		{

			$templateData['PLATAFORM'] = 'IP Game';

		}

              

       

		$strMapFile = '';

		$len = count ($arrayData);

		$templateData['GAMES'] = 0;

		for ($i = 0; $i < $len; $i++)

		{

			$mapData = $this->getMapById ($arrayData[$i]['ID_MAP']);

			$arrayData[$i]['MAP'] = $mapData['Name'] . " (x" . $arrayData[$i]['COUNT'] . ")";

			

			$templateData['GAMES'] += intval ($arrayData[$i]['COUNT']);

			if ($strMapFile == '' && $this->imageMap == '')

			{

				$strMapFile = $mapData;

			}

			if ($firstName == '')

			{

				$firstName = $mapData['Name'];

			}

			$arrayData[$i]['CIV_NAME'] = $aCivData[$arrayData[$i]['ID_CIV']]['NAME'];

			$arrayData[$i]['IMG'] =  '<img src="' . PATH_AOC . $aCivData[$arrayData[$i]['ID_CIV']]['IMAGE'] . '" title="' . $aCivData[$arrayData[$i]['ID_CIV']]['NAME'] . '">'; 

		}



		$templateData['MODE'] =  $aGameModes[intval ($this->mMode)];

		if (is_array ($strMapFile))

		{

			$templateData['MAP_IMG'] = '<img src="' . PATH_TO_MAPS . $strMapFile['Image'] . '" title="' . $strMapFile['Name'] . '">';

		}

		else

		{

			$templateData['MAP_IMG'] = '<img src="' . PATH_TO_UPLOADED_MAPS . $this->imageMap . '" title="' . $firstName . '">';		

		}

		

		$arrayPlayerData = (is_object ($this->mPlayer)) ? $this->mPlayer->toArray () : array ();

		$templateData['FLAG'] = $arrayPlayerData['FLAG'];

		$templateData['PLAYER'] = $arrayPlayerData['NICK'];

		$templateData['ID'] = $arrayPlayerData['ID'];

		

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$templateData['REFRESH'] = TRUE;

			$templateData['RATING_AVG'] = sprintf ("%.2f", $rating / $counter);

			$templateData['RATING'] = $arrayPlayerData['RATING'];

		}

		else

		{

			$templateData['RATING_AVG'] = '-';

			$templateData['RATING'] = '-';

		}

        

        $this->objTemplate->assign_vars (array (

            'RATING_AVG' => $templateData['RATING_AVG'],

            'GAMES' => $templateData['GAMES']

        ));

		

        $this->objTemplate->set_filenames ( array ('maplist' => 'recs/pack_maplist.html'));

        foreach ($arrayData as $mapInfo)

        {                  

            $this->objTemplate->assign_block_vars ('maplist', $mapInfo);

        }

        $templateData['MAPLIST'] = $this->objTemplate->assign_display ('maplist');

        $this->objTemplate->destroy_block_vars ('maplist');

        

		$templateData['RATING'] = $arrayPlayerData['RATING'];



		

		

		$this->objTemplate->set_filenames ( array ('rivals' => 'recs/pack_rivals.html'));

        for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->arrayPlayers[$i]))

			{

				$rival = $this->arrayPlayers[$i]->toArray ();

                $this->objTemplate->assign_block_vars ('rivals', $rival);

			}

		}

        

        $templateData['RIVALS'] = $this->objTemplate->assign_display ('rivals');        

        $this->objTemplate->destroy_block_vars ('rivals');

        

		if (isset ($_GET['updateratings']))

		{

			$templateData['UPDATE'] = '';			

		}

		else

		{

			$templateData['UPDATE'] = '<div style="float: right; font-size: 10px;"><a href="javascript:updateRatings()">Update Ratings</a></div>';

		}

		return $templateData;

	}





	function saveOndb ($attach_id, &$db)

	{

		if (!$this->validRecGameInfo)

		{

			return;

		}



		$this->clearCache (DELETE_PACK);

		

		if ($this->mIdRecgame > 0)

		{

			$this->saveOnDbUpdate ($db);

		}

		else

		{

			if ($this->RecGameAnalized)

			{

				$this->saveOnDbInsertAnalized ($attach_id, $db);

			}

			else

			{

				$this->saveOnDbInsert ($attach_id, $db);

			}

		}

	}

	function saveOnDbUpdate (&$db)

	{

		$strNicks = "'" . $this->mPlayer->getNick()."',";

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->mRivals[$i]))

			{

				$strNicks .= "'" . addslashes ($this->mRivals[$i]->getNick ()) . "',";

			}

		}

		if ($i > 0)

		{

			$strNicks = rtrim ($strNicks, ",");

		}

		if ($this->mPlataform == PLATAFORM_VOOBLY && $this->mMode == 2)

		{

			$this->mPlataformReal = PLATAFORM_VOOBLY_DM;

		}

		else

		{

			$this->mPlataformReal = $this->mPlataform;

		}

				

		$query = "SELECT Id_Player, flag_id, Nick

					 FROM " . TABLE_PLAYERS . "

					 WHERE Nick IN (" . $strNicks . ")";

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$query .= " AND Plataform = '" . $this->mPlataformReal . "'";

		}

		$query .= " GROUP BY Nick

					ORDER BY flag_id DESC, Rating DESC";

		$result = $db->sql_query ($query);

		

		$data = array ();

		while ($pInfo = $db->sql_fetchrow ($result))

		{

			$data[] = $pInfo;	

		}



		$query = "UPDATE " . TABLE_RECGAMES . " SET

					Players = '" . $this->playersCount . "',

					Id_Player = '" . $this->mPlayer->getIdPlayer($data, $db, $this->mPlataformReal) . "',

					Id_Gametype  = '" . $this->mType. "',

				 	Tourney_Name  = '" . addslashes ($this->mTourneyName) . "',

					Plataform  = '" . $this->mPlataform . "',

					Mode = '" . $this->mMode . "'					

					WHERE Id_RecordedGame = '" . $this->idRecordedGame . "'";

					

		$result = $db->sql_query ($query);

		

		$query = "DELETE FROM " . TABLE_REC_PACKGAMES . "

				  WHERE Id_RecordedGame = '" . $this->idRecordedGame . "'";

		$result = $db->sql_query ($query);

		

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->mRivals[$i]))

			{

				$query = "INSERT INTO " . TABLE_REC_PACKGAMES . " VALUES(

					  '" . $this->idRecordedGame . "', 

					  NULL,

					  '" . $this->mCivilizations[$i] . "',

					  '" . $this->mRivals[$i]->getIdPlayer ($data, $db, $this->mPlataformReal) ."',

					  '" . $this->mRivals[$i]->getIdCivilization () ."',

					  '" . $this->mMaps[$i] . "')";

				$result = $db->sql_query ($query);

 			}

		}

 

	

	}

	function saveOnDbInsertAnalized ($attach_id, &$db )

	{

		$strNicks = "'" . $this->mPlayer->getNick () . "',";

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->mRivals[$i]))

			{

				$strNicks .= "'" . addslashes ($this->mRivals[$i]->getNick ()) . "',";

			}

		}

		if ($i > 0)

		{

			$strNicks = rtrim ($strNicks, ",");

		}

		

		if ($this->mPlataform == PLATAFORM_VOOBLY && $this->mMode == 2)

		{

			$this->mPlataformReal = PLATAFORM_VOOBLY_DM;

		}

		else

		{

			$this->mPlataformReal = $this->mPlataform;

		}

				

		$query = "SELECT Id_Player, flag_id, Nick

					 FROM " . TABLE_PLAYERS . "

					 WHERE Nick IN (" . $strNicks . ")";

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$query .= " AND Plataform = '" . $this->mPlataformReal . "'";

		}

		$query .= " GROUP BY Nick

					ORDER BY flag_id DESC, Rating DESC";



		$result = $db->sql_query ($query);

		

		$data = array ();

		while ($pInfo = $db->sql_fetchrow ($result))

		{

			$data[] = $pInfo;	

		}

		

		$this->deleteInfo ($attach_id);

		

		$query = "INSERT INTO " . TABLE_RECGAMES . " VALUES (

					NULL, 

					'" . $attach_id . "',

					'" . $this->mType . "',

					NULL,

					NULL, 

					'" . $this->playersCount . "',

					'" . $this->mPlayer->getIdPlayer ($data, $db, $this->mPlataform) . "',

					NULL,

					'" . addslashes ($this->mTourneyName) . "',

					0,

					'" . $this->imageMap . "',

					'" . $this->mMode . "',

					'" . $this->mPlataform . "'

				)";

		$result = $db->sql_query ($query);



		$this->idRecordedGame = $db->sql_nextid ();

		

		$this->idPlayer = $this->mPlayer->getIdPlayer ($data, $db, $this->mPlataform);

		

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->mRivals[$i]))

			{

				$query = "INSERT INTO " . TABLE_REC_PACKGAMES . " VALUES(

					  '" . $this->idRecordedGame . "', 

					  NULL,

					  '" . $this->mRivals[$i]->IdCivPrincipal . "',

					  '" . $this->mRivals[$i]->getIdPlayer ($data, $db, $this->mPlataformReal) ."',

					  '" . $this->mRivals[$i]->getIdCivilization () ."',

					  '" . $this->ProcessAnalizedMap ($i) . "')";

				$result = $db->sql_query ($query);

			}

		}

	

	}	

	function ProcessAnalizedMap ($index)

	{

		global $db;

		

		$mapRet = '';

		$len = count ($this->mapDataInfo);

		if ($this->mRivals[$index]->mapName != '')

		{

			for ($i = 0; $i < $len; $i++)

			{

				if (strcasecmp ($this->mapDataInfo[$i]['Name'], $this->mRivals[$index]->mapName) == 0)

				{

					$mapRet = $this->mapDataInfo[$i]['Id_Map'] . BREAK_SINGLE . $this->mRivals[$index]->MapQuantity;

					break;

				}

			}

			if ($mapRet == '')

			{

				$query = "INSERT INTO " . TABLE_RECGAMES_MAPS . " VALUES (

								NULL, '" . $this->mRivals[$index]->mapName . "', '')";

				$result = $db->sql_query ($query);

				

				$id = $db->sql_nextid ();



				$this->mapDataInfo[] = array (

					'Id_Map' => $id,

					'Name' => $this->mRivals[$index]->mapName,

					'Image' => '');



				$mapRet = $id . BREAK_SINGLE . $this->mRivals[$index]->MapQuantity;

				@unlink ('cache/cache_maps.php');

			}

		}

		else

		{

			$mapRet = $this->mRivals[$index]->idMap . BREAK_SINGLE . $this->mRivals[$index]->MapQuantity;

		}

		return $mapRet;

	}	

	function saveOnDbInsert ($attach_id, &$db )

	{

		$strNicks = "'" . $this->mPlayer->getNick()."',";

		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->mRivals[$i]))

			{

				$strNicks .= "'" . addslashes ($this->mRivals[$i]->getNick ()) . "',";

			}

		}

		if ($i > 0)

		{

			$strNicks = rtrim ($strNicks, ",");

		}

		$query = "SELECT Id_Player, flag_id, Nick

				 FROM " . TABLE_PLAYERS . "

				 WHERE Nick IN (" . $strNicks . ")";

	

		if ($this->mPlataform != PLATAFORM_IP)

		{

			$query .= " AND Plataform ='" . $this->mPlataform . "'";

		}

		$query .= " GROUP BY Nick

					ORDER BY flag_id DESC, Rating DESC";

		$result = $db->sql_query ($query);

		$data = array ();

		while ($pInfo = $db->sql_fetchrow ($result))

		{

			$data[] = $pInfo;

		}



		$query = "INSERT INTO " . TABLE_RECGAMES . " VALUES (

					NULL, 

					'" . $attach_id . "',

					'" . $this->mType . "',

					NULL,

					NULL, 

					'" . $this->playersCount . "',

					'" . $this->mPlayer->getIdPlayer($data, $db, $this->mPlataform) . "',

					NULL,

					'" . $this->mTourneyName . "',

					0,

					'',

					'" . $this->mMode . "',

					'" . $this->mPlataform . "'

				)";

		$result = $db->sql_query ($query);

		

		$this->idRecordedGame = $db->sql_nextid ();

		

		$this->idPlayer = $this->mPlayer->getIdPlayer($data, $db, $this->mPlataform);



		for ($i = 0; $i < $this->playersCount; $i++)

		{

			if (is_object ($this->mRivals[$i]))

			{

				$query = "INSERT INTO " . TABLE_REC_PACKGAMES . " VALUES(

					  '" . $this->idRecordedGame . "', 

					  NULL,

					  '" . $this->mCivilizations[$i] . "',

					  '" . $this->mRivals[$i]->getIdPlayer ($data, $db, $this->mPlataform) ."',

					  '" . $this->mRivals[$i]->getIdCivilization () ."',

					  '" . $this->mMaps[$i] . "')";

				$result = $db->sql_query ($query);

			}

		}

	

	}

	

	function CreateGame ($file = '', $imageMap = '')

	{

		if ($file != '')

		{

			$this->CreateGameFromPostInfoAnalisis ($file, $imageMap, $_POST['gametype'], $_POST['tourneyname'], $_POST['plataform'], $_POST['idrecgame']);

		}

		else

		{

			$this->CreateGameFromPostInfo ($_POST['mode'], $_POST['gametype'], $_POST['plataform'], $_POST['tourneyname'], $_POST['nick'], $_POST['country'], $_POST['maps'], 

											$_POST['civs'], $_POST['rival'], $_POST['country_rival'], $_POST['civs_rival'], $_POST['quantity'], $_POST['idrecgame']);

		}	

	}

	function CreateGameFromPostInfoAnalisis ($strFile, $imageMap, $iType, $strTourneyName, $iPlataform, $iIdRecordedGame = 0)

	{

		require_once ('recmod/dUnzip.inc.php');

		require_once ('recmod/RecordedGameReader.php');

		

		$this->idRecordedGame = intval ($iIdRecordedGame);

		$this->mType = intval ($iType);

		$this->mPlataform = intval ($iPlataform);

		$this->imageMap = $imageMap;

				

		$this->mMapIds = array ();

		$this->mMaps = array ();

		$this->mRivals = array ();

		$this->playersCount = 0;

		

		$this->RecGameAnalized = TRUE;

		

		if ($this->mType == 4)

		{

			$this->mTourneyName = trim ($strTourneyName);

		}

		else

		{

			$this->mTourneyName = '';

		}

		

		$zipFile = new dUnzip2 ($strFile);

		$list = $zipFile->getList();



		$first = TRUE;

		$this->validRecGameInfo = FALSE;		

		$this->mPlayer = NULL;	

		foreach ($list as $fileName => $zippedFile)

		{

			($first) ? $fileMap = $imageMap : $fileMap = '';



			$zipFile->unzip ($zippedFile['file_name'], 'cache/analizer/rec.mgx');

			$analizer = new RecordedGameReader ('cache/analizer/rec.mgx', $fileMap, 200);

			

			$sucess = $analizer->read (MGX_COMPLETE);

			

			if ($sucess)

			{

				$this->validRecGameInfo = TRUE;			

				if ($first)

				{

					$this->mMode = $analizer->gameTypeId;

				}

				@reset ($analizer->mPlayersInfo);



				

				foreach ($analizer->mPlayersInfo as $player)

				{

					if ($analizer->mIdPlayerView == $player['Key'])

					{

						$principal = $player;

						if ($this->mPlayer == NULL)

						{

							$this->mPlayer = new RecPlayer ($player['Name'], 0, 0);

						}

					}

					else

					{

						$rival = $player;

					}

				}

				

				$existe = FALSE;

				for ($i = 0; $i < count ($this->mRivals); $i++)

				{

					if (strcasecmp ($this->mRivals[$i]->getNick (), $rival['Name']) == 0)

					{

						if (($analizer->mapName != '' && $analizer->mapName == $this->mRivals[$i]->mapName) || $analizer->mMapId == $this->mRivals[$i]->idMap)

						{

							$existe = TRUE;

							$this->mRivals[$i]->MapQuantity ++;

							break;

						}

					}

				}

				if (!$existe)

				{

					$objRival = new RecPlayer ($rival['Name'], $rival['Id_Civ'], 0);

					$objRival->IdCivPrincipal = $principal['Id_Civ'];

					if ($analizer->mMapId == 44 || ($analizer->gameTypeId == 2 && $analizer->mMapId == 30))

					{

						$objRival->mapName = $analizer->mapName;

					}

					else

					{

						$objRival->idMap = $analizer->mMapId;

					}

					$objRival->MapQuantity = 1;

					$this->mRivals[] = $objRival;

				}

				$first = FALSE;

			}

		}

		$this->playersCount = count ($this->mRivals);

		$this->processMapArrayToStringAnalized ();

	}

                       

	function CreateGameFromPostInfo ($iMode, $iType, $iPlataform, $strTourneyName, $strNick, $iIdCountry, $arrayMaps, $arrayCivs, $arrayRival, $arrayCountry, $arrayCivRival, $arrayQuantity, $iIdRecordedGame)

	{

		$this->idRecordedGame = intval ($iIdRecordedGame);

		$this->mPlayer =  new RecPlayer( trim ($strNick), 0 , $iIdCountry);

		$this->mRivals = array ();

		$this->mPlataform = intval ($iPlataform);

		$this->mMode = intval ($iMode);

		$this->mType = intval ($iType);

		$this->playersCount = 0;

		$this->imageMap = '';

		$this->validRecGameInfo = TRUE;

		

		if ($this->mType == 4)

		{

			$this->mTourneyName = trim ($strTourneyName);

		}

		else

		{

			$this->mTourneyName = '';

		}    

		

		for($i = 0; $i < count ($arrayRival); $i++)

		{

			$arrayRival[$i] = trim ($arrayRival[$i]);

			if ($arrayRival[$i] != "")

			{

				$this->playersCount++;

				$this->mRivals[] = new RecPlayer($arrayRival[$i], $arrayCivRival[$i], $arrayCountry[$i]);

				$this->mMaps[] = intval($arrayMaps[$i]) . BREAK_SINGLE . intval ($arrayQuantity[$i]);

				$this->mCivilizations[] = intval ($arrayCivs[$i]);

			}

		}

	}

	function doSelectFromSrt ($strMap, $idCiv)

	{

		global $aCivData;

	

		$split = split (";", $strMap);

		$idMap = intval ($split[0]);

		$iCantidad = intval ($split[1]);

 

		

		$len = count ($this->mapDataInfo);

		

		$mInfo = array ();

		$mInfo['MAPS'] = '';

		$mInfo['QUANTITY'] = '';

		$mInfo['CIVS'] = '';

		

		for ($i = 0; $i < $len; $i++)

		{

			($this->mapDataInfo[$i]['Id_Map'] == $idMap) ? ( $sel = 'selected' ) : ( $sel = '');

			$mInfo['MAPS'] .= '<option value="' . $this->mapDataInfo[$i]['Id_Map'] . '" ' . $sel . '>' . $this->mapDataInfo[$i]['Name'] . '</option>';

		}

		

		for ($i = 1; $i <= 10; $i++)

		{

			($iCantidad == $i) ? ( $sel = 'selected' ) : ( $sel = '');

            $mInfo['QUANTITY'] .= '<option value="' . $i . '" ' . $sel . '>' . $i . '</option>';

		}

		

		@reset ($aCivData);

 

		while (list ($key, $arrayValue ) = each ($aCivData))

		{

			($idCiv == $key) ? ( $sel = 'selected' ) : ( $sel = '');

            $mInfo['CIVS'] .= '<option value="' . $key . '" ' . $sel . '>' . $arrayValue['NAME'] . '</option>';

		}

		return $mInfo;

	}

	function showEdit ($attach_id, &$db)

	{

		global $user, $aGameModes, $aGameData;

        

		

		$returnData = array ();

		

		$query = "SELECT r.Players, play.Id_Player as Main_Id, play.Nick as Main_Nick, play.flag_id as Main_Id_Flag,

				    pak.Id_Civilization, p.Nick, p.Rating, p.flag_id, pak.Maps, pak.Id_CivRival, r.Mode, r.Id_Gametype, r.Tourney_Name, r.Plataform

				  FROM " . TABLE_RECGAMES . " r, " . TABLE_REC_PACKGAMES . " pak, " . TABLE_PLAYERS . " p," . TABLE_PLAYERS . " play

				    WHERE r.Id_RecordedGame = pak.Id_RecordedGame

				        AND pak.Id_Rival = p.Id_Player

				        AND r.attach_id = '" . $attach_id . "'

				        AND r.Id_Player = play.Id_Player";

		$result = $db->sql_query ($query);

		$load = FALSE;

		

        $arrayData = array ();

        $arrayPlayers = array ();

		

        while ($datos = $db->sql_fetchrow ($result))

		{

			if (!$load)

			{

				$load = TRUE;

				$this->mPlayer = new RecPlayer ($datos['Main_Nick'], 0, $datos['Main_Id_Flag']);

				$this->mPlataform = $datos['Plataform'];

				$this->mMode = $datos['Mode'];

				$this->mTourneyName = $datos['Tourney_Name'];

				$this->mType = $datos['Id_Gametype'];

				$this->playersCount = $datos['Players'];

			}

			$arrayData[] = array ('CIV' => $datos['Id_Civilization'], 'MAP' => $datos['Maps'] );

			$arrayPlayers[] = new RecPlayer($datos['Nick'], $datos['Id_CivRival'], $datos['flag_id']);

		}



        $query = "SELECT flag_id, flag_country

                    FROM " . TABLE_FLAGS . "

                    ORDER BY flag_country ASC";

        $result = $db->sql_query ($query);

        $aFlags = array ();

        while ($flag = $db->sql_fetchrow ($result))

        {

            $aFlags[] = $flag;

            $this->objTemplate->assign_block_vars ('flag', array (

                'VALUE' => $flag['flag_id'],

                'NAME' => $flag['flag_country'],

                'SELECTED' => ( $this->mPlayer->mIdFlag == $flag['flag_id'] ) ? ( 'selected' ) : ( '' )

            ));

        }

        $arrayFlags = array_merge (array (-1 => array(

            'flag_id' => 0,

            'flag_country' => "Country")) , $aFlags);

            

        $mgxInfo = array ();

		

        

		for($i = 0; $i < count ($arrayPlayers); $i++)

		{

			$arrayPlayer = $arrayPlayers[$i]->toArrayToEdit ($arrayFlags);

			$arrayPlayer = array_merge (array ('NRO' => ( $i + 1 )) , $arrayPlayer, $this->doSelectFromSrt ($arrayData[$i]['MAP'], $arrayData[$i]['CIV']));

			   

			$this->objTemplate->assign_block_vars ('pack_player', $arrayPlayer);

		}

		

        @reset ($aGameModes);

		$mgxInfo['modes'] = array ();

		foreach ($aGameModes as $key => $value)

		{

			$this->objTemplate->assign_block_vars ('modes', array (

				'VALUE' => $key,

				'NAME' => $value,

				'SELECTED' => ( $this->mMode == $key ) ? ( 'selected' ) : ( '' )

			));	

		}



		@reset ($aGameData);

		foreach ($aGameData as $key => $value)

		{

            $this->objTemplate->assign_block_vars ('types', array (

				'VALUE' => $key,

				'NAME' => $value,

				'SELECTED' => ( $this->mType == $key ) ? ( 'selected' ) : ( '' )

			));

		}		

		$mgxInfo += $this->mPlayer->toArrayToEdit ($arrayFlags);

		

		$this->objTemplate->assign_vars (array (

            'TOURNEY' => $this->mTourneyName,

            'NICK' => $this->mPlayer->getNick()

        ));

        

        if (in_array ($this->mPlataform, array (1,2)))

        {

            $this->objTemplate->assign_vars ( array (

                'VOOBLY_CHECKED' => 'checked="checked" ',

                'IP_CHECKED' => '')

            );

        }

        else

        {

            $this->objTemplate->assign_vars ( array (

                'IP_CHECKED' => 'checked="checked" ',

                'VOOBLY_CHECKED' => '')

            );

        }



		return $mgxInfo;

	}

}

?>