<?php

/**

 * Recorded Game Extension

 * ------------------------------

 * @author jose rolando mdos

 *         @ http://wwww.pia-clan.com

 * @date  : Sbado, 5/11/05 4:24 PM

 * @update: Mircoles, Septiembre 27, 2006 4:03 PM

 * @update: Monday, July 19, 2010 11:23 AM

 **/

  

define ('NO_FLAG', 0);

define ('DELETE_NORMAL', 1);

define ('DELETE_PACK', 2);

define ('DELETE_ALL', 3);



class RecordedGame

{

	var $objTemplate;

	var $arrayPlayers;

	var $mapDataInfo;

	

	function RecordedGame ()

	{

		global $user, $db;

		global $phpbb_root_path;

		

		include ($phpbb_root_path . '/recmod/aoc_lang.php');

		

        $sql = 'SELECT * 

				    FROM ' . TABLE_RECGAMES_MAPS . ' 

				ORDER BY Id_Map'; 

		$result = $db->sql_query($sql);

		$this->mapDataInfo = array ();

		while ($datos = $db->sql_fetchrow ($result))

		{

			$this->mapDataInfo[] = $datos;

		}

	}

	

	function setTemplate (&$template)

	{

		$this->objTemplate = &$template;

	}

	

	function deleteInfo ($attach_id)

	{

		global $db;

		

		$query = "SELECT Id_RecordedGame

					FROM " . TABLE_RECGAMES . "

						WHERE attach_id = '" . $attach_id . "'";

		$id = $db->sql_fetchrow ($db->sql_query ($query));

		if ($id['Id_RecordedGame'] > 0)

		{

			$query = "DELETE FROM " . TABLE_RECGAMES . "

						WHERE Id_RecordedGame = '" . $id['Id_RecordedGame'] . "'";

			$db->sql_query ($query);						

			

			$query = "DELETE FROM " . TABLE_RECGAMES_PLAY . "

						WHERE Id_RecordedGame = '" . $id['Id_RecordedGame'] . "'";

			$db->sql_query ($query);



			$query = "DELETE FROM " . TABLE_REC_PACKGAMES . "

						WHERE Id_RecordedGame = '" . $id['Id_RecordedGame'] . "'";

			$db->sql_query($query);

            

            @unlink (PATH_TO_UPLOADED_MAPS . 'map_' . $attach_id . '.png');

			$this->clearCache (DELETE_NORMAL);

		}

	}

	function getMapById ($id)

	{

		$len = count ($this->mapDataInfo);

		$return = array ();

		for ($i = 0; $i < $len; $i++)

		{			

			if ($this->mapDataInfo[$i]['Id_Map'] == $id)

			{

				$return = $this->mapDataInfo[$i];

				break;

			}

		}

		return $return;

	}



	function clearCache ($type = DELETE_NORMAL)

	{

		switch ($type)

		{

			case DELETE_NORMAL:

				@unlink ('cache/' . LAST_GAMES_CACHE_TEAM);

				@unlink ('cache/' . LAST_GAMES_CACHE_SOLO);

				break;

			case DELETE_PACK:

				@unlink ('cache/' . LAST_GAMES_CACHE_PACK);

				break;

			case DELETE_ALL:

				@unlink ('cache/' . LAST_GAMES_CACHE_TEAM);

				@unlink ('cache/' . LAST_GAMES_CACHE_SOLO);

				@unlink ('cache/' . LAST_GAMES_CACHE_PACK);			

			break;

		}

		@unlink ('cache/' . LAST_GAMES_CACHE);	

	}

	function createFromIdToTemplate ($attach_id, &$db)

	{

	}

	

	function parseMapArrayToString ($arrayMaps)

	{

		$retStr = '';

		for ($i = 0; $i < count ($arrayMaps); $i++)

		{

			$retStr .= $arrayMaps[$i]['ID_MAP'] . BREAK_SINGLE . $arrayMaps[$i]['COUNT'] . BREAK_DATA;

		}

		if ($i > 0)

		{

			$retStr = rtrim ($retStr, BREAK_DATA);

		}

		return $retStr;

	}

	function parseMapStringToArray ($strMaps)

	{

		$retArray = array ();

		$splitData = split (BREAK_DATA, $strMaps);

		for ($i = 0; $i < count ($splitData); $i++)

		{

			$arrayMap = split (BREAK_SINGLE, $splitData[$i]);

			if (count ($arrayMap) == 2)

			{

				$retArray[] = array (

					'ID_MAP' => intval ($arrayMap[0]),

					'COUNT' => intval ($arrayMap[1])

				);

			}

		}

		return $retArray;

	}

	

	function processMapArrayToStringAnalized ()

	{

		global $db;

		$arrayMaps = array_count_values ($this->mMaps);

		$arrayMapsIds = array ();

		$arrayInsertMapIds = array ();

		$retStr = "";



		if (is_array ($arrayMaps))

		{

			@reset ($arrayMaps);

			$size = count ($this->mapDataInfo);

			foreach ($arrayMaps as $map => $count)

			{

				$added = FALSE;

				for ($i = 0; $i < $size; $i++)

				{

					if (strcasecmp ($map, $this->mapDataInfo[$i]['Name']) == 0)

					{

						$arrayMapsIds[] = array (

							'ID' => $this->mapDataInfo[$i]['Id_Map'],

							'COUNT' => $count

						);

						$added = TRUE;

						break;

					}

				}

				if (!$added)

				{

					$query = "INSERT INTO " . TABLE_RECGAMES_MAPS . " VALUES (

								NULL, '" . $map . "', NULL)";

					$db->sql_query ($query);

					$id = $db->sql_nextid ();

					$this->mapDataInfo[] = array (

						'Map_Id' => $id,

						'Name' => $map,

						'Image' => ''

					);

					$arrayMapsIds[] = array (

						'ID' => $id,

						'COUNT' => $count

					);

				}

			}

			

			

			foreach ($arrayMapsIds as $mapPlayed)

			{

				$retStr .= $mapPlayed['ID'] . BREAK_SINGLE . $mapPlayed['COUNT'] . BREAK_DATA;

			}

			

			if (is_array ($this->mMapIds))

			{

				$this->mMapIds = array_count_values ($this->mMapIds);

				@reset ($this->mMapIds);

				foreach ($this->mMapIds as $mapId => $count)

				{

					$retStr .= $mapId . BREAK_SINGLE . $count . BREAK_DATA;

				}

			}

			if ($retStr != "")

			{

				$retStr = substr ($retStr, 0, strlen ($retStr) - strlen (BREAK_DATA));

			}			

		}

		return $retStr;

	}	

 

	function saveOnDb ()

	{

	}

	function showCreate ()

	{

	}

	function CreateGame ()

	{

	}

	function showEdit ()

	{

	}

	

}









class RecPlayer

{

	var $mNick;

	var $mIdFlag;

	var $mIdCivilization;

	var $mId;

	

	function setIdPlayer ($idPlayer)

	{

		$this->mId = $idPlayer;

	}

	function getIdCivilization ()

	{

		return $this->mIdCivilization;

	}

	function getNick ()

	{

		return $this->mNick;

	}

	function getIdPlayer (&$data, &$db, $plataform)

	{

		if ($this->mId > 0)

		{

			return $this->mId;

		}

		$registrado = FALSE;

		$this->mId = 0;

		for ($i = 0; $i < count ($data); $i++)

		{

			if (strcasecmp ($data[$i]['Nick'], $this->mNick) == 0)

			{

				$registrado = TRUE;

				$this->mId = $data[$i]['Id_Player'];

				$this->mRating = $data[$i]['Rating'];

				if ($data[$i]['flag_id'] != $this->mIdFlag && $this->mIdFlag > 0)

				{

					$query = "UPDATE " . TABLE_PLAYERS . " 

								SET flag_id = '" . $this->mIdFlag . "'

								WHERE Id_Player = '" . $data[$i]['Id_Player'] . "'";

					$db->sql_query ($query);

				}

				break;

				

			}

		}

		if (!$registrado)

		{

			$this->mRating = 1600;

			if ($this->mIdFlag == 0)

			{

				$query = "SELECT flag_id

						  FROM " . TABLE_PLAYERS . "

						  WHERE Nick = '" . addslashes ($this->mNick) . "'

						  ORDER BY flag_id DESC

						  LIMIT 1";

				$flagAuxData = $db->sql_fetchrow ($db->sql_query ($query));

				$this->mIdFlag = intval ($flagAuxData['flag_id']);

			}

			$query = "INSERT INTO " . TABLE_PLAYERS . " VALUES (

					  NULL,

					  '" . addslashes ($this->mNick) . "',

					  '" . $this->mIdFlag . "',

					  1600,

					  '" . $plataform . "',

					  0

					  )";

			$db->sql_query ($query);		

			$this->mId = $db->sql_nextid();

		}

		return $this->mId;

	

	}

	function toArray ()

	{

		global $aCivData;	

		

		$arrayReturn = array (

			'CIV' => $aCivData[ $this->mIdCivilization ]['NAME'],

			'IMG' => '<img src="' . PATH_AOC . $aCivData[ $this->mIdCivilization ]['IMAGE'] . '" title="' . $aCivData[ $this->mIdCivilization ]['NAME'] . '">',

			'NICK' => $this->mNick,

			'RATING' => $this->mRating,

			'ID' => $this->mPlataformId

		);

		

		if ($this->mIdFlag != NO_FLAG)

		{

			$arrayReturn['FLAG'] = '<img src="' . PATH_FLAGS . $this->mFlagUrl . '" title="' . $this->mFlagName . '" align="top" border="0">';

		}



		return $arrayReturn;

	}

	function toArrayAsSingle ($objDb, $index)

	{

		$arrayReturn = array ();

		$arrayReturn['PLAYER' . $index] = $this->mNick;

		if ($this->mIdFlag != NO_FLAG)

		{

			$arrayFlag = $objDb->getFlag ($this->mIdFlag);

			$arrayReturn['FLAG' . $index] = '<img src="' . PATH_FLAGS . $arrayFlag['Image'] . '" title="' . $arrayFlag['NAME'] . '" border="0">';

		}

		return $arrayReturn;

	}

	function RecPlayer ($strNick, $iIdCivilization, $iIdFlag, $strFlagName = "", $strFlagUrl = "", $strRating = "", $strId = "")

	{

		$this->mNick = $strNick;

		$this->mIdFlag = intval ($iIdFlag);

		$this->mIdCivilization = intval ($iIdCivilization);

		$this->mFlagName = $strFlagName;

		$this->mFlagUrl = $strFlagUrl;

		$this->mRating = $strRating;

		$this->mPlataformId = $strId;

	}

	function printPlayerToEdit (&$arrayFlags, &$template, $index)

	{

		global $aCivData;

		@reset ($arrayFlags);

		

		while( list ($iKey, $arrayValue ) = each ($arrayFlags))

		{

			$template->assign_block_vars ('flag' . $index, array (

				'VALUE' => $arrayValue['flag_id'],

				'NAME' => $arrayValue['flag_country'],

				'SELECTED' => ( $this->mIdFlag == $arrayValue['flag_id'] ) ? ( 'selected' ) : ( '' )

			));

		}

		@reset ($aCivData);

		while (list ($iKey, $arrayValue ) = each ($aCivData))

		{

			$template->assign_block_vars ('civs' . $index, array (

				'VALUE' => $iKey,

				'NAME' => $arrayValue['NAME'],

				'SELECTED' => ( $this->mIdCivilization == $iKey ) ? ( 'selected' ) : ( '' )

			));

		}

		$template->assign_vars (array ('PLAYER' . $index => $this->mNick));

	}

	function toArrayToEdit (&$arrayFlags)

	{

		global $aCivData;

		

		@reset ($arrayFlags);

		$len = count ($arrayFlags);

		

		$optFlags = '';

		

		for ($i = 0; $i < $len; $i++)

		{

			( $this->mIdFlag == $arrayFlags[$i]['flag_id'] ) ? ( $sel = 'selected' ) : ( $sel = '' );

			$optFlags .= '<option value="' . $arrayFlags[$i]['flag_id'] . '" ' . $sel . '>' . $arrayFlags[$i]['flag_country'] . '</option>';

		}

		

		$optCivs = "";

		@reset ($aCivData);

		while (list ($iKey, $arrayValue ) = each ($aCivData))

		{

			( $this->mIdCivilization == $iKey ) ? ( $sel = 'selected' ) : ( $sel = '' );

			$optCivs .= '<option value="' . $iKey . '" ' . $sel . '>' . $arrayValue['NAME'] . '</option>';

		}

		return array (

			'NICK' => $this->mNick,

			'FLAG' => $optFlags,

			'CIV' => $optCivs

		);

	}

}



require ('recmod/RecordedGameNormal.php');

require ('recmod/RecordedGamePack.php');



?>